﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Configuration;
using Microsoft.ServiceBus;
using System.Configuration;

namespace DemoService
{
    public class ServiceRegistry : BehaviorExtensionElement
    {
        public override Type BehaviorType
        {
            get { return typeof(ServiceRegistrySettings); }
        }
        protected override object CreateBehavior()
        {
            return new ServiceRegistrySettings()
            {
                DiscoveryMode = this.DiscoveryMode,
                DisplayName = this.DisplayName
            };
        }
        [ConfigurationProperty("discoveryMode", DefaultValue = DiscoveryType.Private)]
        public DiscoveryType DiscoveryMode
        {
            get { return (DiscoveryType)this["discoveryMode"]; }
            set { this["discoveryMode"] = value; }
        }
        [ConfigurationProperty("displayName")]
        public string DisplayName
        {
            get { return (string)this["displayName"]; }
            set { this["displayName"] = value; }
        }
    }
}
