﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.ServiceBus;
using System.ServiceModel;
using DemoService;
using Microsoft.ApplicationServer.Caching;
using System.Diagnostics;
using System.Configuration;

namespace WebRole
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }
        protected void SearchSB_Clicked(object sender, EventArgs e)
        {
            DataCache dc = new DataCache();
            string serviceNamespaceDomain = ConfigurationManager.AppSettings["serviceNamespaceDomain"] as string ;
            string issuerName = ConfigurationManager.AppSettings["issuerName"] as string;
            string issuerSecret = ConfigurationManager.AppSettings["issuerSecret"] as string;
            try
            {
                Stopwatch sw = new Stopwatch();
                sw.Start();
                Uri serviceUri = ServiceBusEnvironment.CreateServiceUri("sb", serviceNamespaceDomain, "ServiceNetTcp");

                TransportClientEndpointBehavior sharedSecretServiceBusCredential = new TransportClientEndpointBehavior();

                sharedSecretServiceBusCredential .TokenProvider =TokenProvider.CreateSharedSecretTokenProvider(issuerName, issuerSecret);

                 // create the channel factory loading the configuration
                ChannelFactory<IService> channelFactory = new ChannelFactory<IService>("RelayEndpoint", new EndpointAddress(serviceUri));
                // apply the Service Bus credentials
                channelFactory.Endpoint.Behaviors.Add(sharedSecretServiceBusCredential);
                // create and open the client channel
                
                IService channel = channelFactory.CreateChannel();
                ((ICommunicationObject)channel).Open();

                List<string> result = channel.GetData(txtKeyword .Text);
                
                ((ICommunicationObject)channel).Close();
                channelFactory.Close();
                if (result != null)
                {
                    dc.Add(txtKeyword.Text, result);
                    grdResult.DataSource = result;
                    grdResult.DataBind();
                }
                else
                {
                    grdResult.DataSource = null;
                    grdResult.DataBind();
                }
                sw.Stop();
                Response.Write("Total duration:" + sw.ElapsedMilliseconds.ToString());

            }
            catch (Exception ex)
            {
                txtKeyword.Text = ex.Message;
            }
        }

        protected void SearchSB2_Clicked(object sender, EventArgs e)
        {


            try
            {
               
                DataCache dc = new DataCache();
                Stopwatch sw = new Stopwatch();
                sw.Start();
                List<string> result = dc.Get(txtKeyword.Text) as List<string>;
                if (result != null)
                {
                    grdResult.DataSource = result;
                    grdResult.DataBind();
                }
                else
                {
                    grdResult.DataSource = null;
                    grdResult.DataBind();
                }
                sw.Stop();
                Response.Write("Total duration:" + sw.ElapsedMilliseconds.ToString());
            }
            catch (Exception ex)
            {
                txtKeyword.Text = ex.Message;
            }
        }
    }
}
